library(nlme)
ordinalMatrix=read.table('C:\\Users\\User\\Desktop\\papers\\WW\\dror\\datafiles\\correct-ord.csv',header = TRUE, sep = ",")


dataMatrix=matrix(0,nrow=1706, ncol=60)
dataMatrix=as.data.frame(dataMatrix)
colnames(dataMatrix)<-c(1:60)
colnames(dataMatrix)[1]<-'time'
colnames(dataMatrix)[2]<-'subject'
colnames(dataMatrix)[3:42]<- colnames(mydata)[2:41]
colnames(dataMatrix)[43]<-'age_greater_30'   #>=30
colnames(dataMatrix)[44]<-'female'
colnames(dataMatrix)[45]<-'selfTaught'
colnames(dataMatrix)[46]<-'BA_MA'
colnames(dataMatrix)[47]<-'yearsofexperience_greater_5'  #>=6
colnames(dataMatrix)[48]<-'assess_greater_4'             #>=5
colnames(dataMatrix)[55]<-'ordinal'
colnames(dataMatrix)[56]<-'ordinalBinary'


row=0


for (i in 1:nrow(mydata)){
  
  ###########   age   ########
  age=0
  temp=mydata$age[i]
  if (temp>=30){
    age=1
  }
  
  ###########    gender   ########
  gender=0
  temp=mydata$gender[i]
  if (temp=="female"){
    gender=1
  }
  
  ###########    selfTaught   ########
  selftaught=0
  temp=mydata$selftaught[i]
  if (temp==TRUE){
    selftaught=1
  }  
  if (temp=='null'){
    selftaught=NA
  }  
  
  
  ###########    BA_MA   ########
  BA_MA=0
  if (mydata$phdfinised[i]==TRUE | mydata$mafinised[i]==TRUE | mydata$bafinised[i]==TRUE) {
    BA_MA=1
  } else {
    if ( mydata$bafinised[i]==FALSE | mydata$bafinised[i]=='null') {
      BA_MA=0
    }
  }
  
   

  
  
  ###########    yearsofexperience   ########
  yearsofexperience=0
  temp=mydata$yearsofexperience[i]
  if (temp=='null'){
    yearsofexperience=NA
  } else {
    if (as.numeric(as.character(temp))>=5){
    yearsofexperience=1
    } 
  }


  
  ###########    assess   ########
  assess=0
  temp=mydata$assess[i]
  if (temp=='null'){
    assess=NA
  }  else  {
    if (as.numeric(as.character(temp))>=4){
    assess=1
  }    
  }

  
  for (j in 2:41){
    temp=mydata[i,j]
    ordinal=ordinalMatrix[i,j]
    if (is.na(temp)==TRUE){
      print(temp)
      next
    }
    
    
    
    if (is.na(temp)==FALSE){
      
    }
   
    row=row+1
    time=temp
    
    #dataMatrix=rbind(dataMatrix,rep(0,60))
    
    dataMatrix$time[row]=time
    dataMatrix$subject[row]=i
    dataMatrix[row,j+1]=1
    dataMatrix$age_greater_30[row]=age  
    dataMatrix$female[row]=gender
    dataMatrix$selfTaught[row]=selftaught
    dataMatrix$BA_MA[row]=BA_MA
    dataMatrix$yearsofexperience_greater_5[row]=yearsofexperience
    dataMatrix$assess_greater_4[row]=assess
    dataMatrix$ordinal[row]=ordinal
    if (ordinal==1){
      dataMatrix$ordinalBinary[row]=0}
    if (ordinal>1){
      dataMatrix$ordinalBinary[row]=1}
    
    
    
    
    
  }
  
}


colnames(dataMatrix)[1]<-'time'
colnames(dataMatrix)[2]<-'subject'
colnames(dataMatrix)[3:42]<- colnames(mydata)[2:41]
colnames(dataMatrix)[43]<-'age_greater_30'   #>=30
colnames(dataMatrix)[44]<-'female'
colnames(dataMatrix)[45]<-'selfTaught'
colnames(dataMatrix)[46]<-'BA_MA'
colnames(dataMatrix)[47]<-'yearsofexperience_greater_5'  #>=6
colnames(dataMatrix)[48]<-'assess_greater_4'             #>=5



colnames(dataMatrix)[49]<-'question'
for (i in 3:42){
  dataMatrix$question[which(dataMatrix[,i]!=0)]=i-2
}


HC <- groupedData(time ~ dataMatrix[,3:56]|as.factor(subject) ,data = dataMatrix) 


fm2 <- lme((time)~           
             +factor(age_greater_30)+factor(female)+
             factor(yearsofexperience_greater_5)+factor(BA_MA)+
             +factor(assess_greater_4)+factor(question),
           data = HC,  na.action=na.omit,
           random = ~ 1|subject)
summary(fm2)




fm2 <- lme((time)~           
             +factor(age_greater_30)+factor(female)+
             factor(yearsofexperience_greater_5)+factor(BA_MA)+
             +factor(assess_greater_4),
           data = HC,  na.action=na.omit,
           random = ~ 1|subject)
summary(fm2)

fm22 <- lme((time)~           
             +factor(age_greater_30)+factor(female)+
             factor(yearsofexperience_greater_5)+factor(BA_MA)+
             +factor(assess_greater_4)+ordinal,
           data = HC,  na.action=na.omit,
           random = ~ 1|subject)
summary(fm22)

fm222 <- lme((time)~           
              +factor(age_greater_30)+factor(female)+
              factor(yearsofexperience_greater_5)+factor(BA_MA)+
              +factor(assess_greater_4)+(ordinalBinary),
            data = HC,  na.action=na.omit,
            random = ~ 1|subject)
summary(fm222)









fm2 <- lme((time)~           
             +factor(age_greater_30)+factor(question),
           data = HC,  na.action=na.omit,
           random = ~ 1|subject)
summary(fm2)


fm2 <- lme((time)~           
             +factor(female)+factor(question),
           data = HC,  na.action=na.omit,
           random = ~ 1|subject)
summary(fm2)

fm2 <- lme((time)~           
             +factor(yearsofexperience_greater_5)+factor(question),
           data = HC,  na.action=na.omit,
           random = ~ 1|subject)
summary(fm2)


fm2 <- lme((time)~           
             +factor(BA_MA)+factor(question),
           data = HC,  na.action=na.omit,
           random = ~ 1|subject)
summary(fm2)


fm2 <- lme((time)~           
             +factor(assess_greater_4)+factor(question),
           data = HC,  na.action=na.omit,
           random = ~ 1|subject)
summary(fm2)



