



############################################################################################################
############################################################################################################
####################################    permutation test function       ####################################
############################################################################################################
############################################################################################################
pairedPermutation<-function(pair,num,indicator){
  
  weightedT<-function(diff,indicator){
    
    groups=max(indicator)
    result=0
    groups1=groups
    for (i in 1:groups){
      temp=diff[which(indicator[,1]==i)]
      if (length(temp)<=1){
        groups1=groups1-1
        next
      }
      result=result+sqrt(length(temp))*mean(temp)/sd(temp)
    }
    result=result/groups1
    return(result)
    
  }
  
  
  
  statisticVectr=vector(length=num)
  c=dim(pair)
  c=c[1]
  
  for (i in 1:num){
    
    temp=rbinom(c,1,.5)
    newpair=pair
    newpair[which(temp==1),1]=pair[which(temp==1),2]
    newpair[which(temp==1),2]=pair[which(temp==1),1]
    diff=newpair[,2]-newpair[,1]
    #statisticVectr[i]=length(diff)*mean(diff)/sd(diff)
    statisticVectr[i]=weightedT(diff,indicator)
    
  }
  
  
  diff=pair[,2]-pair[,1]
  value=weightedT(diff,indicator)
  statisticVectr[num+1]=value
  
  
  return(statisticVectr)
  
}

############################################################################################################
############################################################################################################
####################################   creating wilcoxon pair matrix      ##################################
############################################################################################################
############################################################################################################


wilcxMat<-function(pair,indicator){
  pair1=pair
  groups=max(indicator)
  
  for (i in 1:groups){
    len=length(which(indicator==i))
    if (len<=1){
      next
    }
    temp=as.vector(pair[which(indicator==i),])
    mean1=mean(temp)
    sd1=sd(temp)
    pair1[which(indicator==i),]=(pair[which(indicator==i),]-mean1)/sd1
    
    
    
  }
  return(pair1) 
  
}

############################################################################################################
############################################################################################################
####################################          creating pair matrix      ####################################
############################################################################################################
############################################################################################################
testGroups<-function(correct,groupMatrix){
  
  u=dim(groupMatrix)
  u=u[1]
  pair=matrix(nrow=0,ncol=2)
  indicator=matrix(nrow=0,ncol=1)
  
  
  
  for (i in 1:obs){
    temp=colnames(correct[which(!is.na(correct[i,]))])
    for (ind in 1:u){
      if (groupMatrix[ind,1] %in% temp   &  groupMatrix[ind,2] %in% temp  ){
        pair=rbind(pair,c(get(groupMatrix[ind,1],pos=correct[i,]),get(groupMatrix[ind,2],pos=correct[i,])))
        indicator=rbind(indicator,c(ind))
      }
    }
  }
  return(cbind(pair,indicator))
}
#########################################################
###########################################################

wilcxPermutation<-function(pair,num,indicator){
  
  wilcx<-function(pair,indicator){
    
    zz=rank(abs(pair[,2]-pair[,1]))
    zz1=sign(pair[,2]-pair[,1])
    us=zz*zz1
    groups=max(indicator)
    tt=0
    group1=groups
    for (i in 1:groups){
      len=length(which(indicator==i))
      if (len<=1){
        next
        group1=group1-1
      }
      tt=tt+sqrt(length(which(indicator==i)))*sum(us[which(indicator==i)])/sd(us[which(indicator==i)])
      #zz[which(indicator==i)]=zz[which(indicator==i)]/sd(zz)
    }
    return(tt/group1)
  }
  
  
  
  statisticVectr=vector(length=num)
  c=dim(pair)
  c=c[1]
  
  for (i in 1:num){
    
    temp=rbinom(c,1,.5)
    newpair=pair
    newpair[which(temp==1),1]=pair[which(temp==1),2]
    newpair[which(temp==1),2]=pair[which(temp==1),1]
    #print(newpair-pair)
    diff=(newpair[,2]-newpair[,1])
    #statisticVectr[i]=length(diff)*mean(diff)/sd(diff)
    statisticVectr[i]=wilcx(newpair,indicator)
    
  }
  
  
  
  value=wilcx(pair,indicator)
  statisticVectr[num+1]=value
  
  
  return(statisticVectr)
  
}


#########################################################
###########################################################

effectSize<-function(group1,group2){
  vector1=c()
  vector2=c()
  for (i in 1:length(group1)){
    temp=group1[i]
    if(temp %in% colnames(correct)){
      vector1=c(vector1,correct[,c(temp)][which(!is.na(correct[,c(temp)]))])
    }
  }
  for (i in 1:length(group2)){
    temp=group2[i]
    if(temp %in% colnames(correct)){
      vector2=c(vector2,correct[,c(temp)][which(!is.na(correct[,c(temp)]))])
    }
  }
  
  n1=length(vector1)
  n2=length(vector2)
  s1=sd(vector1)
  s2=sd(vector2)
  
  
  sdd1=-(mean(vector2)-mean(vector1))/(      sqrt(   ( (n1-1)*s1*s1+(n2-1)*s2*s2  )/ (n1+n2-2)  )       )
  sdd2=-(mean(vector2)-mean(vector1))/(sd(c(vector1,vector2)))
  return(c(sdd1,sdd2))
  
}





############################################################################################################
############################################################################################################
############################################################################################################
############################################################################################################

wrong=read.table("wrong.csv", header = TRUE, sep = ",") 
correct=read.table("correct.csv", header = TRUE, sep = ",")


resultMat=matrix(nrow=0,ncol=7)
colnames(resultMat)<-c("groups","mean_group1","mean_group2","observations" ,"permutation","wilcoxon","effect size")
temp=dim(correct)
obs=temp[1]


##################################################################################
#                           {al,bl,cl}-{as,bs,cs}               #
##################################################################################
groupMatrix=matrix(nrow=0,ncol=2)

groupMatrix=rbind(groupMatrix,c("three.aLogic","three.aStructure"))
groupMatrix=rbind(groupMatrix,c("three.bLogic","three.bStructure"))
groupMatrix=rbind(groupMatrix,c("three.cLogic","three.cStructure"))

group1=c("three.aLogic","three.bLogic","three.cLogic")
group2=c("three.aStructure","three.bStructure","three.cStructure")
es=effectSize(group1,group2)

title="{al,bl,cl}-{as,bs,cs}"


#########
matrix1=testGroups(correct,groupMatrix)
pair=as.matrix(matrix1[,1:2])
indicator=as.matrix(matrix1[,3])
siz=dim(pair)
siz=siz[1]
num=20000
statisticVectr<-pairedPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
pval=findInterval(value,sort(statisticVectr))/num




num=20000
statisticVectr<-wilcxPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
a=findInterval(value,sort(statisticVectr))/num

print(a)
summary(a)
m1=round(mean(matrix1[,1]),1)
m2=round(mean(matrix1[,2]),1)
sd1=round(sd(matrix1[,1]),1)
sd2=round(sd(matrix1[,2]),1)
temp=dim(matrix1)
temp=temp[1]
resultMat=rbind(resultMat,c(title,paste0(toString(m1),"(",toString(sd1),")"),paste0(toString(m2),"(",toString(sd2),")"),temp,pval,a,es[1] ))
##########


##################################################################################
#                           check {as,cs}-{al,cl}              #
##################################################################################
groupMatrix=matrix(nrow=0,ncol=2)

groupMatrix=rbind(groupMatrix,c("three.aStructure","three.aLogic"))
groupMatrix=rbind(groupMatrix,c("three.cStructure","three.cLogic"))

group1=c("three.aStructure","three.cStructure")
group2=c("three.aLogic","three.cLogic")
es=effectSize(group1,group2)

title="{as,cs}-{al,cl}"


#########
matrix1=testGroups(correct,groupMatrix)
pair=as.matrix(matrix1[,1:2])
indicator=as.matrix(matrix1[,3])
siz=dim(pair)
siz=siz[1]
num=20000
statisticVectr<-pairedPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
pval=findInterval(value,sort(statisticVectr))/num



num=20000
statisticVectr<-wilcxPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
a=findInterval(value,sort(statisticVectr))/num

print(a)
summary(a)
m1=round(mean(matrix1[,1]),1)
m2=round(mean(matrix1[,2]),1)
sd1=round(sd(matrix1[,1]),1)
sd2=round(sd(matrix1[,2]),1)
temp=dim(matrix1)
temp=temp[1]
resultMat=rbind(resultMat,c(title,paste0(toString(m1),"(",toString(sd1),")"),paste0(toString(m2),"(",toString(sd2),")"),temp,pval,a,es[1] ))
##########

##################################################################################
#                           check {al}-{as}                #
##################################################################################
groupMatrix=matrix(nrow=0,ncol=2)

groupMatrix=rbind(groupMatrix,c("three.aLogic","three.aStructure"))


group1=c("three.aLogic")
group2=c("three.aStructure")
es=effectSize(group1,group2)

title="{al}-{as}"


#########
matrix1=testGroups(correct,groupMatrix)
pair=as.matrix(matrix1[,1:2])
indicator=as.matrix(matrix1[,3])
siz=dim(pair)
siz=siz[1]
num=20000
statisticVectr<-pairedPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
pval=findInterval(value,sort(statisticVectr))/num


num=20000
statisticVectr<-wilcxPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
a=findInterval(value,sort(statisticVectr))/num
print(a)
summary(a)
m1=round(mean(matrix1[,1]),1)
m2=round(mean(matrix1[,2]),1)
sd1=round(sd(matrix1[,1]),1)
sd2=round(sd(matrix1[,2]),1)
temp=dim(matrix1)
temp=temp[1]
resultMat=rbind(resultMat,c(title,paste0(toString(m1),"(",toString(sd1),")"),paste0(toString(m2),"(",toString(sd2),")"),temp,pval,a,es[1] ))
##########


##################################################################################
#                           check {cl}-{cs}               #
##################################################################################
groupMatrix=matrix(nrow=0,ncol=2)

groupMatrix=rbind(groupMatrix,c("three.cLogic","three.cStructure"))
group1=c("three.cLogic")
group2=c("three.cStructure")
es=effectSize(group1,group2)

title="{cl}-{cs}"


#########
matrix1=testGroups(correct,groupMatrix)
pair=as.matrix(matrix1[,1:2])
indicator=as.matrix(matrix1[,3])
siz=dim(pair)
siz=siz[1]
num=20000
statisticVectr<-pairedPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
pval=findInterval(value,sort(statisticVectr))/num


num=20000
statisticVectr<-wilcxPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
a=findInterval(value,sort(statisticVectr))/num
print(a)
summary(a)
m1=round(mean(matrix1[,1]),1)
m2=round(mean(matrix1[,2]),1)
sd1=round(sd(matrix1[,1]),1)
sd2=round(sd(matrix1[,2]),1)
temp=dim(matrix1)
temp=temp[1]
resultMat=rbind(resultMat,c(title,paste0(toString(m1),"(",toString(sd1),")"),paste0(toString(m2),"(",toString(sd2),")"),temp,pval,a,es[1] ))
##########


##################################################################################
#                           {bl}-{bs}              #
##################################################################################
groupMatrix=matrix(nrow=0,ncol=2)

groupMatrix=rbind(groupMatrix,c("three.bLogic","three.bStructure"))
group1=c("three.bLogic")
group2=c("three.bStructure")
es=effectSize(group1,group2)

title="{bl}-{bs}"


#########
matrix1=testGroups(correct,groupMatrix)
pair=as.matrix(matrix1[,1:2])
indicator=as.matrix(matrix1[,3])
siz=dim(pair)
siz=siz[1]
num=20000
statisticVectr<-pairedPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
pval=findInterval(value,sort(statisticVectr))/num
#dat <- with(density(statisticVectr), data.frame(x, y))
#ggplot(data = dat, mapping = aes(x = x, y = y)) + layer(geom = "line") +layer(geom = "area", mapping = aes(x = ifelse(x>value, x, 0)),
#geom_params = list(fill = "red", alpha = 0.5)) +scale_y_continuous(limits = c(0, max(dat$y)))+ggtitle(paste0(title," :p-value: ",toString(pval)))
#ggsave(paste0(title,".jpeg"))

num=20000
statisticVectr<-wilcxPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
a=findInterval(value,sort(statisticVectr))/num
print(a)
summary(a)
m1=round(mean(matrix1[,1]),1)
m2=round(mean(matrix1[,2]),1)
sd1=round(sd(matrix1[,1]),1)
sd2=round(sd(matrix1[,2]),1)
temp=dim(matrix1)
temp=temp[1]
resultMat=rbind(resultMat,c(title,paste0(toString(m1),"(",toString(sd1),")"),paste0(toString(m2),"(",toString(sd2),")"),temp,pval,a,es[1] ))
##########


##################################################################################
#                           {bl}-{bl1}               #
##################################################################################
groupMatrix=matrix(nrow=0,ncol=2)

groupMatrix=rbind(groupMatrix,c("three.bLogic","three.b1Logic"))
group1=c("three.bLogic")
group2=c("three.b1Logic")
es=effectSize(group1,group2)

title="{bl}-{bl1}"


#########
matrix1=testGroups(correct,groupMatrix)
pair=as.matrix(matrix1[,1:2])
indicator=as.matrix(matrix1[,3])
siz=dim(pair)
siz=siz[1]
num=20000
statisticVectr<-pairedPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
pval=findInterval(value,sort(statisticVectr))/num
#dat <- with(density(statisticVectr), data.frame(x, y))
#ggplot(data = dat, mapping = aes(x = x, y = y)) + layer(geom = "line") +layer(geom = "area", mapping = aes(x = ifelse(x>value, x, 0)),
#geom_params = list(fill = "red", alpha = 0.5)) +scale_y_continuous(limits = c(0, max(dat$y)))+ggtitle(paste0(title," :p-value: ",toString(pval)))
#ggsave(paste0(title,".jpeg"))

num=20000
statisticVectr<-wilcxPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
a=findInterval(value,sort(statisticVectr))/num
print(a)
summary(a)
m1=round(mean(matrix1[,1]),1)
m2=round(mean(matrix1[,2]),1)
sd1=round(sd(matrix1[,1]),1)
sd2=round(sd(matrix1[,2]),1)
temp=dim(matrix1)
temp=temp[1]
resultMat=rbind(resultMat,c(title,paste0(toString(m1),"(",toString(sd1),")"),paste0(toString(m2),"(",toString(sd2),")"),temp,pval,a,es[1] ))
##########

##################################################################################
#                           {bl}-{al}           #
##################################################################################
groupMatrix=matrix(nrow=0,ncol=2)

groupMatrix=rbind(groupMatrix,c("three.bLogic","three.aLogic"))
group1=c("three.bLogic")
group2=c("three.aLogic")
es=effectSize(group1,group2)

title="{bl}-{al}"


#########
matrix1=testGroups(correct,groupMatrix)
pair=as.matrix(matrix1[,1:2])
indicator=as.matrix(matrix1[,3])
siz=dim(pair)
siz=siz[1]
num=20000
statisticVectr<-pairedPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
pval=findInterval(value,sort(statisticVectr))/num
#dat <- with(density(statisticVectr), data.frame(x, y))
#ggplot(data = dat, mapping = aes(x = x, y = y)) + layer(geom = "line") +layer(geom = "area", mapping = aes(x = ifelse(x>value, x, 0)),
#geom_params = list(fill = "red", alpha = 0.5)) +scale_y_continuous(limits = c(0, max(dat$y)))+ggtitle(paste0(title," :p-value: ",toString(pval)))
#ggsave(paste0(title,".jpeg"))

num=20000
statisticVectr<-wilcxPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
a=findInterval(value,sort(statisticVectr))/num
print(a)
summary(a)
m1=round(mean(matrix1[,1]),1)
m2=round(mean(matrix1[,2]),1)
sd1=round(sd(matrix1[,1]),1)
sd2=round(sd(matrix1[,2]),1)
temp=dim(matrix1)
temp=temp[1]
resultMat=rbind(resultMat,c(title,paste0(toString(m1),"(",toString(sd1),")"),paste0(toString(m2),"(",toString(sd2),")"),temp,pval,a,es[1] ))
##########

##################################################################################
#                           "{bl}-{cl}"               #
##################################################################################
groupMatrix=matrix(nrow=0,ncol=2)

groupMatrix=rbind(groupMatrix,c("three.bLogic","three.cLogic"))
group1=c("three.bLogic")
group2=c("three.cLogic")
es=effectSize(group1,group2)

title="{bl}-{cl}"


#########
matrix1=testGroups(correct,groupMatrix)
pair=as.matrix(matrix1[,1:2])
indicator=as.matrix(matrix1[,3])
siz=dim(pair)
siz=siz[1]
num=20000
statisticVectr<-pairedPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
pval=findInterval(value,sort(statisticVectr))/num
#dat <- with(density(statisticVectr), data.frame(x, y))
#ggplot(data = dat, mapping = aes(x = x, y = y)) + layer(geom = "line") +layer(geom = "area", mapping = aes(x = ifelse(x>value, x, 0)),
#geom_params = list(fill = "red", alpha = 0.5)) +scale_y_continuous(limits = c(0, max(dat$y)))+ggtitle(paste0(title," :p-value: ",toString(pval)))
#ggsave(paste0(title,".jpeg"))

num=20000
statisticVectr<-wilcxPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
a=findInterval(value,sort(statisticVectr))/num
print(a)
summary(a)
m1=round(mean(matrix1[,1]),1)
m2=round(mean(matrix1[,2]),1)
sd1=round(sd(matrix1[,1]),1)
sd2=round(sd(matrix1[,2]),1)
temp=dim(matrix1)
temp=temp[1]
resultMat=rbind(resultMat,c(title,paste0(toString(m1),"(",toString(sd1),")"),paste0(toString(m2),"(",toString(sd2),")"),temp,pval,a,es[1] ))
##########

##################################################################################
#                           {an}-{al}                    #
##################################################################################
groupMatrix=matrix(nrow=0,ncol=2)

groupMatrix=rbind(groupMatrix,c("three.aLogicNegative","three.aLogic"))
group1=c("three.aLogicNegative")
group2=c("three.aLogic")
es=effectSize(group1,group2)

title="{an}-{al}"


#########
matrix1=testGroups(correct,groupMatrix)
pair=as.matrix(matrix1[,1:2])
indicator=as.matrix(matrix1[,3])
siz=dim(pair)
siz=siz[1]
num=20000
statisticVectr<-pairedPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
pval=findInterval(value,sort(statisticVectr))/num
#dat <- with(density(statisticVectr), data.frame(x, y))
#ggplot(data = dat, mapping = aes(x = x, y = y)) + layer(geom = "line") +layer(geom = "area", mapping = aes(x = ifelse(x>value, x, 0)),
#geom_params = list(fill = "red", alpha = 0.5)) +scale_y_continuous(limits = c(0, max(dat$y)))+ggtitle(paste0(title," :p-value: ",toString(pval)))
#ggsave(paste0(title,".jpeg"))

num=20000
statisticVectr<-wilcxPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
a=findInterval(value,sort(statisticVectr))/num
print(a)
summary(a)
m1=round(mean(matrix1[,1]),1)
m2=round(mean(matrix1[,2]),1)
sd1=round(sd(matrix1[,1]),1)
sd2=round(sd(matrix1[,2]),1)
temp=dim(matrix1)
temp=temp[1]
resultMat=rbind(resultMat,c(title,paste0(toString(m1),"(",toString(sd1),")"),paste0(toString(m2),"(",toString(sd2),")"),temp,pval,a,es[1] ))
##########


##################################################################################
#                           {an1}-{al}                 #
##################################################################################
groupMatrix=matrix(nrow=0,ncol=2)

groupMatrix=rbind(groupMatrix,c("three.aLogicNegative1","three.aLogic"))
group1=c("three.aLogicNegative1")
group2=c("three.aLogic")
es=effectSize(group1,group2)

title="{an1}-{al}"


#########
matrix1=testGroups(correct,groupMatrix)
pair=as.matrix(matrix1[,1:2])
indicator=as.matrix(matrix1[,3])
siz=dim(pair)
siz=siz[1]
num=20000
statisticVectr<-pairedPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
pval=findInterval(value,sort(statisticVectr))/num
#dat <- with(density(statisticVectr), data.frame(x, y))
#ggplot(data = dat, mapping = aes(x = x, y = y)) + layer(geom = "line") +layer(geom = "area", mapping = aes(x = ifelse(x>value, x, 0)),
#geom_params = list(fill = "red", alpha = 0.5)) +scale_y_continuous(limits = c(0, max(dat$y)))+ggtitle(paste0(title," :p-value: ",toString(pval)))
#ggsave(paste0(title,".jpeg"))

num=20000
statisticVectr<-wilcxPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
a=findInterval(value,sort(statisticVectr))/num
print(a)
summary(a)
m1=round(mean(matrix1[,1]),1)
m2=round(mean(matrix1[,2]),1)
sd1=round(sd(matrix1[,1]),1)
sd2=round(sd(matrix1[,2]),1)
temp=dim(matrix1)
temp=temp[1]
resultMat=rbind(resultMat,c(title,paste0(toString(m1),"(",toString(sd1),")"),paste0(toString(m2),"(",toString(sd2),")"),temp,pval,a,es[1] ))
##########

##################################################################################
#                           {an2}-{al}                  #
##################################################################################
groupMatrix=matrix(nrow=0,ncol=2)

groupMatrix=rbind(groupMatrix,c("three.aLogicNegative2","three.aLogic"))
group1=c("three.aLogicNegative2")
group2=c("three.aLogic")
es=effectSize(group1,group2)

title="{an2}-{al}"


#########
matrix1=testGroups(correct,groupMatrix)
pair=as.matrix(matrix1[,1:2])
indicator=as.matrix(matrix1[,3])
siz=dim(pair)
siz=siz[1]
num=20000
statisticVectr<-pairedPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
pval=findInterval(value,sort(statisticVectr))/num
#dat <- with(density(statisticVectr), data.frame(x, y))
#ggplot(data = dat, mapping = aes(x = x, y = y)) + layer(geom = "line") +layer(geom = "area", mapping = aes(x = ifelse(x>value, x, 0)),
#geom_params = list(fill = "red", alpha = 0.5)) +scale_y_continuous(limits = c(0, max(dat$y)))+ggtitle(paste0(title," :p-value: ",toString(pval)))
#ggsave(paste0(title,".jpeg"))

num=20000
statisticVectr<-wilcxPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
a=findInterval(value,sort(statisticVectr))/num
print(a)
summary(a)
m1=round(mean(matrix1[,1]),1)
m2=round(mean(matrix1[,2]),1)
sd1=round(sd(matrix1[,1]),1)
sd2=round(sd(matrix1[,2]),1)
temp=dim(matrix1)
temp=temp[1]
resultMat=rbind(resultMat,c(title,paste0(toString(m1),"(",toString(sd1),")"),paste0(toString(m2),"(",toString(sd2),")"),temp,pval,a,es[1] ))
##########

##################################################################################
#                           {an,an1,an2}-{al}                   #
##################################################################################
groupMatrix=matrix(nrow=0,ncol=2)

groupMatrix=rbind(groupMatrix,c("three.aLogicNegative","three.aLogic"))
groupMatrix=rbind(groupMatrix,c("three.aLogicNegative1","three.aLogic"))
groupMatrix=rbind(groupMatrix,c("three.aLogicNegative2","three.aLogic"))

group1=c("three.aLogicNegative","three.aLogicNegative1","three.aLogicNegative2")
group2=c("three.aLogic")
es=effectSize(group1,group2)

title="{an,an1,an2}-{al}"


#########
matrix1=testGroups(correct,groupMatrix)
pair=as.matrix(matrix1[,1:2])
indicator=as.matrix(matrix1[,3])
siz=dim(pair)
siz=siz[1]
num=20000
statisticVectr<-pairedPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
pval=findInterval(value,sort(statisticVectr))/num
#dat <- with(density(statisticVectr), data.frame(x, y))
#ggplot(data = dat, mapping = aes(x = x, y = y)) + layer(geom = "line") +layer(geom = "area", mapping = aes(x = ifelse(x>value, x, 0)),
#geom_params = list(fill = "red", alpha = 0.5)) +scale_y_continuous(limits = c(0, max(dat$y)))+ggtitle(paste0(title," :p-value: ",toString(pval)))
#ggsave(paste0(title,".jpeg"))

num=20000
statisticVectr<-wilcxPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
a=findInterval(value,sort(statisticVectr))/num
print(a)
summary(a)
m1=round(mean(matrix1[,1]),1)
m2=round(mean(matrix1[,2]),1)
sd1=round(sd(matrix1[,1]),1)
sd2=round(sd(matrix1[,2]),1)
temp=dim(matrix1)
temp=temp[1]
resultMat=rbind(resultMat,c(title,paste0(toString(m1),"(",toString(sd1),")"),paste0(toString(m2),"(",toString(sd2),")"),temp,pval,a,es[1] ))
##########

##################################################################################
#                          {f*,f[]}-{as,cs}                     #
##################################################################################
groupMatrix=matrix(nrow=0,ncol=2)

groupMatrix=rbind(groupMatrix,c("three.forArithmetic","three.aStructure"))
groupMatrix=rbind(groupMatrix,c("three.forArithmetic","three.cStructure"))
groupMatrix=rbind(groupMatrix,c("three.forArray","three.aStructure"))
groupMatrix=rbind(groupMatrix,c("three.forArray","three.cStructure"))

group1=c("three.forArithmetic","three.forArray")
group2=c("three.aStructure","three.cStructure")
es=effectSize(group1,group2)

title="{f*,f[]}-{as,cs}"


#########
matrix1=testGroups(correct,groupMatrix)
pair=as.matrix(matrix1[,1:2])
indicator=as.matrix(matrix1[,3])
siz=dim(pair)
siz=siz[1]
num=20000
statisticVectr<-pairedPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
pval=findInterval(value,sort(statisticVectr))/num
#dat <- with(density(statisticVectr), data.frame(x, y))
#ggplot(data = dat, mapping = aes(x = x, y = y)) + layer(geom = "line") +layer(geom = "area", mapping = aes(x = ifelse(x>value, x, 0)),
#geom_params = list(fill = "red", alpha = 0.5)) +scale_y_continuous(limits = c(0, max(dat$y)))+ggtitle(paste0(title," :p-value: ",toString(pval)))
#ggsave(paste0(title,".jpeg"))

num=20000
statisticVectr<-wilcxPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
a=findInterval(value,sort(statisticVectr))/num
print(a)
summary(a)
m1=round(mean(matrix1[,1]),1)
m2=round(mean(matrix1[,2]),1)
sd1=round(sd(matrix1[,1]),1)
sd2=round(sd(matrix1[,2]),1)
temp=dim(matrix1)
temp=temp[1]
resultMat=rbind(resultMat,c(title,paste0(toString(m1),"(",toString(sd1),")"),paste0(toString(m2),"(",toString(sd2),")"),temp,pval,a,es[1] ))
##########

##################################################################################
#                           {f*}-{as}                  #
##################################################################################
groupMatrix=matrix(nrow=0,ncol=2)

groupMatrix=rbind(groupMatrix,c("three.forArithmetic","three.aStructure"))

group1=c("three.forArithmetic")
group2=c("three.aStructure")
es=effectSize(group1,group2)


title="{f*}-{as}"


#########
matrix1=testGroups(correct,groupMatrix)
pair=as.matrix(matrix1[,1:2])
indicator=as.matrix(matrix1[,3])
siz=dim(pair)
siz=siz[1]
num=20000
statisticVectr<-pairedPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
pval=findInterval(value,sort(statisticVectr))/num
#dat <- with(density(statisticVectr), data.frame(x, y))
#ggplot(data = dat, mapping = aes(x = x, y = y)) + layer(geom = "line") +layer(geom = "area", mapping = aes(x = ifelse(x>value, x, 0)),
#geom_params = list(fill = "red", alpha = 0.5)) +scale_y_continuous(limits = c(0, max(dat$y)))+ggtitle(paste0(title," :p-value: ",toString(pval)))
#ggsave(paste0(title,".jpeg"))

num=20000
statisticVectr<-wilcxPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
a=findInterval(value,sort(statisticVectr))/num
print(a)
summary(a)
m1=round(mean(matrix1[,1]),1)
m2=round(mean(matrix1[,2]),1)
sd1=round(sd(matrix1[,1]),1)
sd2=round(sd(matrix1[,2]),1)
temp=dim(matrix1)
temp=temp[1]
resultMat=rbind(resultMat,c(title,paste0(toString(m1),"(",toString(sd1),")"),paste0(toString(m2),"(",toString(sd2),")"),temp,pval,a,es[1] ))
##########

##################################################################################
#                           {f[]}-{as}                   #
##################################################################################
groupMatrix=matrix(nrow=0,ncol=2)

groupMatrix=rbind(groupMatrix,c("three.forArray","three.aStructure"))

group1=c("three.forArray")
group2=c("three.aStructure")
es=effectSize(group1,group2)

title="{f[]}-{as}"


#########
matrix1=testGroups(correct,groupMatrix)
pair=as.matrix(matrix1[,1:2])
indicator=as.matrix(matrix1[,3])
siz=dim(pair)
siz=siz[1]
num=20000
statisticVectr<-pairedPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
pval=findInterval(value,sort(statisticVectr))/num
#dat <- with(density(statisticVectr), data.frame(x, y))
#ggplot(data = dat, mapping = aes(x = x, y = y)) + layer(geom = "line") +layer(geom = "area", mapping = aes(x = ifelse(x>value, x, 0)),
#geom_params = list(fill = "red", alpha = 0.5)) +scale_y_continuous(limits = c(0, max(dat$y)))+ggtitle(paste0(title," :p-value: ",toString(pval)))
#ggsave(paste0(title,".jpeg"))

num=20000
statisticVectr<-wilcxPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
a=findInterval(value,sort(statisticVectr))/num
print(a)
summary(a)
m1=round(mean(matrix1[,1]),1)
m2=round(mean(matrix1[,2]),1)
sd1=round(sd(matrix1[,1]),1)
sd2=round(sd(matrix1[,2]),1)
temp=dim(matrix1)
temp=temp[1]
resultMat=rbind(resultMat,c(title,paste0(toString(m1),"(",toString(sd1),")"),paste0(toString(m2),"(",toString(sd2),")"),temp,pval,a,es[1] ))
##########


##################################################################################
#                           {f*}-{cs}                     #
##################################################################################
groupMatrix=matrix(nrow=0,ncol=2)


groupMatrix=rbind(groupMatrix,c("three.forArithmetic","three.cStructure"))


group1=c("three.forArithmetic")
group2=c("three.cStructure")
es=effectSize(group1,group2)

title="{f*}-{cs}"


#########
matrix1=testGroups(correct,groupMatrix)
pair=as.matrix(matrix1[,1:2])
indicator=as.matrix(matrix1[,3])
siz=dim(pair)
siz=siz[1]
num=20000
statisticVectr<-pairedPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
pval=findInterval(value,sort(statisticVectr))/num
#dat <- with(density(statisticVectr), data.frame(x, y))
#ggplot(data = dat, mapping = aes(x = x, y = y)) + layer(geom = "line") +layer(geom = "area", mapping = aes(x = ifelse(x>value, x, 0)),
#geom_params = list(fill = "red", alpha = 0.5)) +scale_y_continuous(limits = c(0, max(dat$y)))+ggtitle(paste0(title," :p-value: ",toString(pval)))
#ggsave(paste0(title,".jpeg"))

num=20000
statisticVectr<-wilcxPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
a=findInterval(value,sort(statisticVectr))/num
print(a)
summary(a)
m1=round(mean(matrix1[,1]),1)
m2=round(mean(matrix1[,2]),1)
sd1=round(sd(matrix1[,1]),1)
sd2=round(sd(matrix1[,2]),1)
temp=dim(matrix1)
temp=temp[1]
resultMat=rbind(resultMat,c(title,paste0(toString(m1),"(",toString(sd1),")"),paste0(toString(m2),"(",toString(sd2),")"),temp,pval,a,es[1] ))
##########

##################################################################################
#                           {f[]}-{cs}                   #
##################################################################################
groupMatrix=matrix(nrow=0,ncol=2)

groupMatrix=rbind(groupMatrix,c("three.forArray","three.cStructure"))

group1=c("three.forArray")
group2=c("three.cStructure")
es=effectSize(group1,group2)



title="{f[]}-{cs}"


#########
matrix1=testGroups(correct,groupMatrix)
pair=as.matrix(matrix1[,1:2])
indicator=as.matrix(matrix1[,3])
siz=dim(pair)
siz=siz[1]
num=20000
statisticVectr<-pairedPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
pval=findInterval(value,sort(statisticVectr))/num
#dat <- with(density(statisticVectr), data.frame(x, y))
#ggplot(data = dat, mapping = aes(x = x, y = y)) + layer(geom = "line") +layer(geom = "area", mapping = aes(x = ifelse(x>value, x, 0)),
#geom_params = list(fill = "red", alpha = 0.5)) +scale_y_continuous(limits = c(0, max(dat$y)))+ggtitle(paste0(title," :p-value: ",toString(pval)))
#ggsave(paste0(title,".jpeg"))

num=20000
statisticVectr<-wilcxPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
a=findInterval(value,sort(statisticVectr))/num
print(a)
summary(a)
m1=round(mean(matrix1[,1]),1)
m2=round(mean(matrix1[,2]),1)
sd1=round(sd(matrix1[,1]),1)
sd2=round(sd(matrix1[,2]),1)
temp=dim(matrix1)
temp=temp[1]
resultMat=rbind(resultMat,c(title,paste0(toString(m1),"(",toString(sd1),")"),paste0(toString(m2),"(",toString(sd2),")"),temp,pval,a,es[1] ))
##########












##################################################################################
#         check {seg3}-{seg2}                   #
##################################################################################
groupMatrix=matrix(nrow=0,ncol=2)

groupMatrix=rbind(groupMatrix,c("three.aLogicNegative2","two.aLogicNegative2"))
groupMatrix=rbind(groupMatrix,c("three.bStructure","two.bStructure"))
groupMatrix=rbind(groupMatrix,c("three.forArray","two.forArray"))
groupMatrix=rbind(groupMatrix,c("three.aLogic","two.aLogic"))
groupMatrix=rbind(groupMatrix,c("three.aStructure","two.aStructure"))
groupMatrix=rbind(groupMatrix,c("three.cLogic","two.cLogic"))
groupMatrix=rbind(groupMatrix,c("three.aLogicNegative","two.aLogicNegative"))
groupMatrix=rbind(groupMatrix,c("three.b1Logic","two.b1Logic"))
groupMatrix=rbind(groupMatrix,c("three.cStructure","two.cStructure"))
groupMatrix=rbind(groupMatrix,c("three.aLogicNegative1","two.aLogicNegative1"))
groupMatrix=rbind(groupMatrix,c("three.bLogic","two.bLogic"))
groupMatrix=rbind(groupMatrix,c("three.forArithmetic","two.forArithmetic"))
title="{seg3}-{seg2}"

group1=c("three.aLogicNegative2","three.bStructure","three.forArray","three.aLogic","three.aStructure","three.cLogic","three.aLogicNegative","three.b1Logic","three.cStructure","three.aLogicNegative1","three.bLogic","three.forArithmetic")
group2=c("two.aLogicNegative2","two.bStructure","two.forArray","two.aLogic","two.aStructure","two.cLogic","two.aLogicNegative","two.b1Logic","two.cStructure","two.aLogicNegative1","two.bLogic","two.forArithmetic")



es=effectSize(group1,group2)


#########
matrix1=testGroups(correct,groupMatrix)
pair=as.matrix(matrix1[,1:2])
indicator=as.matrix(matrix1[,3])
siz=dim(pair)
siz=siz[1]
num=20000
statisticVectr<-pairedPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
pval=findInterval(value,sort(statisticVectr))/num
#dat <- with(density(statisticVectr), data.frame(x, y))
#ggplot(data = dat, mapping = aes(x = x, y = y)) + layer(geom = "line") +layer(geom = "area", mapping = aes(x = ifelse(x>value, x, 0)),
#geom_params = list(fill = "red", alpha = 0.5)) +scale_y_continuous(limits = c(0, max(dat$y)))+ggtitle(paste0(title," :p-value: ",toString(pval)))
#ggsave(paste0(title,".jpeg"))

num=20000
statisticVectr<-wilcxPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
a=findInterval(value,sort(statisticVectr))/num
print(a)
summary(a)
m1=round(mean(matrix1[,1]),1)
m2=round(mean(matrix1[,2]),1)
sd1=round(sd(matrix1[,1]),1)
sd2=round(sd(matrix1[,2]),1)
temp=dim(matrix1)
temp=temp[1]
resultMat=rbind(resultMat,c(title,paste0(toString(m1),"(",toString(sd1),")"),paste0(toString(m2),"(",toString(sd2),")"),temp,pval,a,es[1] ))
##########

##################################################################################
#         {seg4}-{seg3}                     #
##################################################################################
groupMatrix=matrix(nrow=0,ncol=2)

groupMatrix=rbind(groupMatrix,c("four.aLogicNegative2","three.aLogicNegative2"))
groupMatrix=rbind(groupMatrix,c("four.bStructure","three.bStructure"))
groupMatrix=rbind(groupMatrix,c("four.forArray","three.forArray"))
groupMatrix=rbind(groupMatrix,c("four.aLogic","three.aLogic"))
groupMatrix=rbind(groupMatrix,c("four.aStructure","three.aStructure"))
groupMatrix=rbind(groupMatrix,c("four.cLogic","three.cLogic"))
groupMatrix=rbind(groupMatrix,c("four.aLogicNegative","three.aLogicNegative"))
groupMatrix=rbind(groupMatrix,c("four.b1Logic","three.b1Logic"))
groupMatrix=rbind(groupMatrix,c("four.cStructure","three.cStructure"))
groupMatrix=rbind(groupMatrix,c("four.aLogicNegative1","three.aLogicNegative1"))
groupMatrix=rbind(groupMatrix,c("four.bLogic","three.bLogic"))
groupMatrix=rbind(groupMatrix,c("four.forArithmetic","three.forArithmetic"))
title="{seg4}-{seg3}"

group1=c("four.aLogicNegative2","four.bStructure","four.forArray","four.aLogic","four.aStructure","four.cLogic","four.aLogicNegative",
         "four.b1Logic", "four.cStructure", "four.aLogicNegative1",  "four.bLogic", "four.forArithmetic"    )
group2=c("three.aLogicNegative2", "three.bStructure","three.forArray","three.aLogic","three.aStructure","three.cLogic","three.aLogicNegative",
         "three.b1Logic","three.cStructure","three.aLogicNegative1","three.bLogic","three.forArithmetic")
es=effectSize(group1,group2)



#########
matrix1=testGroups(correct,groupMatrix)
pair=as.matrix(matrix1[,1:2])
indicator=as.matrix(matrix1[,3])
siz=dim(pair)
siz=siz[1]
num=20000
statisticVectr<-pairedPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
pval=findInterval(value,sort(statisticVectr))/num
#dat <- with(density(statisticVectr), data.frame(x, y))
#ggplot(data = dat, mapping = aes(x = x, y = y)) + layer(geom = "line") +layer(geom = "area", mapping = aes(x = ifelse(x>value, x, 0)),
#geom_params = list(fill = "red", alpha = 0.5)) +scale_y_continuous(limits = c(0, max(dat$y)))+ggtitle(paste0(title," :p-value: ",toString(pval)))
#ggsave(paste0(title,".jpeg"))

num=20000
statisticVectr<-wilcxPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
a=findInterval(value,sort(statisticVectr))/num
print(a)
summary(a)
m1=round(mean(matrix1[,1]),1)
m2=round(mean(matrix1[,2]),1)
sd1=round(sd(matrix1[,1]),1)
sd2=round(sd(matrix1[,2]),1)
temp=dim(matrix1)
temp=temp[1]
resultMat=rbind(resultMat,c(title,paste0(toString(m1),"(",toString(sd1),")"),paste0(toString(m2),"(",toString(sd2),")"),temp,pval,a,es[1] ))
#########



##################################################################################
#                         {sp2-4}-{sp0-1}                   #
##################################################################################
groupMatrix=matrix(nrow=0,ncol=2)


groupMatrix=rbind(groupMatrix,c("special.forArr2","special.forArr0"))
groupMatrix=rbind(groupMatrix,c("special.forArr3","special.forArr0"))
groupMatrix=rbind(groupMatrix,c("special.forArr4","special.forArr0"))
groupMatrix=rbind(groupMatrix,c("special.forArr2","special.forArr1"))
groupMatrix=rbind(groupMatrix,c("special.forArr3","special.forArr1"))
groupMatrix=rbind(groupMatrix,c("special.forArr4","special.forArr1"))


title="{sp2-4}-{sp0-1}"

group1=c("special.forArr2","special.forArr3","special.forArr4")
group2=c("special.forArr0","special.forArr1")
es=effectSize(group1,group2)


#########
matrix1=testGroups(correct,groupMatrix)
pair=as.matrix(matrix1[,1:2])
indicator=as.matrix(matrix1[,3])
siz=dim(pair)
siz=siz[1]
num=20000
statisticVectr<-pairedPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
pval=findInterval(value,sort(statisticVectr))/num
#dat <- with(density(statisticVectr), data.frame(x, y))
#ggplot(data = dat, mapping = aes(x = x, y = y)) + layer(geom = "line") +layer(geom = "area", mapping = aes(x = ifelse(x>value, x, 0)),
#geom_params = list(fill = "red", alpha = 0.5)) +scale_y_continuous(limits = c(0, max(dat$y)))+ggtitle(paste0(title," :p-value: ",toString(pval)))
#ggsave(paste0(title,".jpeg"))

num=20000
statisticVectr<-wilcxPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
a=findInterval(value,sort(statisticVectr))/num
print(a)
summary(a)
m1=round(mean(matrix1[,1]),1)
m2=round(mean(matrix1[,2]),1)
sd1=round(sd(matrix1[,1]),1)
sd2=round(sd(matrix1[,2]),1)
temp=dim(matrix1)
temp=temp[1]
resultMat=rbind(resultMat,c(title,paste0(toString(m1),"(",toString(sd1),")"),paste0(toString(m2),"(",toString(sd2),")"),temp,pval,a,es[1] ))

##########


##################################################################################
#                         check research question special sp5-6 vs 0-1          #
##################################################################################
groupMatrix=matrix(nrow=0,ncol=2)


groupMatrix=rbind(groupMatrix,c("special.forArr5","special.forArr0"))
groupMatrix=rbind(groupMatrix,c("special.forArr6","special.forArr0"))
groupMatrix=rbind(groupMatrix,c("special.forArr5","special.forArr1"))
groupMatrix=rbind(groupMatrix,c("special.forArr6","special.forArr1"))


title="{sp5-6}-{sp0-1}"

group1=c("special.forArr5","special.forArr6")
group2=c("special.forArr0","special.forArr1")
es=effectSize(group1,group2)

#########
matrix1=testGroups(correct,groupMatrix)
pair=as.matrix(matrix1[,1:2])
indicator=as.matrix(matrix1[,3])
siz=dim(pair)
siz=siz[1]
num=20000
statisticVectr<-pairedPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
pval=findInterval(value,sort(statisticVectr))/num
#dat <- with(density(statisticVectr), data.frame(x, y))
#ggplot(data = dat, mapping = aes(x = x, y = y)) + layer(geom = "line") +layer(geom = "area", mapping = aes(x = ifelse(x>value, x, 0)),
#geom_params = list(fill = "red", alpha = 0.5)) +scale_y_continuous(limits = c(0, max(dat$y)))+ggtitle(paste0(title," :p-value: ",toString(pval)))
#ggsave(paste0(title,".jpeg"))

num=20000
statisticVectr<-wilcxPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
a=findInterval(value,sort(statisticVectr))/num
print(a)
summary(a)
m1=round(mean(matrix1[,1]),1)
m2=round(mean(matrix1[,2]),1)
sd1=round(sd(matrix1[,1]),1)
sd2=round(sd(matrix1[,2]),1)
temp=dim(matrix1)
temp=temp[1]
resultMat=rbind(resultMat,c(title,paste0(toString(m1),"(",toString(sd1),")"),paste0(toString(m2),"(",toString(sd2),")"),temp,pval,a,es[1] ))

##########
