



############################################################################################################
############################################################################################################
####################################    permutation test function       ####################################
############################################################################################################
############################################################################################################
pairedPermutation<-function(pair,num,indicator){
  
  weightedT<-function(diff,indicator){
    
    groups=max(indicator)
    result=0
    groups1=groups
    for (i in 1:groups){
      temp=diff[which(indicator[,1]==i)]
      if (length(temp)<=1){
        groups1=groups1-1
        next
      }
      result=result+sqrt(length(temp))*mean(temp)/sd(temp)
    }
    result=result/groups1
    return(result)
    
  }
  
  
  
  statisticVectr=vector(length=num)
  c=dim(pair)
  c=c[1]
  
  for (i in 1:num){
    
    temp=rbinom(c,1,.5)
    newpair=pair
    newpair[which(temp==1),1]=pair[which(temp==1),2]
    newpair[which(temp==1),2]=pair[which(temp==1),1]
    diff=(newpair[,2]-newpair[,1])
    #statisticVectr[i]=length(diff)*mean(diff)/sd(diff)
    statisticVectr[i]=weightedT(diff,indicator)
    
  }
  
  
  diff=(pair[,2]-pair[,1])
  value=weightedT(diff,indicator)
  statisticVectr[num+1]=value
  
  
  return(statisticVectr)
  
}

############################################################################################################
############################################################################################################
####################################   creating wilcoxon pair matrix      ##################################
############################################################################################################
############################################################################################################


wilcxMat<-function(pair,indicator){
  pair1=pair
  groups=max(indicator)
  
  for (i in 1:groups){
    len=length(which(indicator==i))
    if (len<=1){
      next
    }
    temp=as.vector(pair[which(indicator==i),])
    mean1=mean(temp)
    sd1=sd(temp)
    pair1[which(indicator==i),]=(pair[which(indicator==i),]-mean1)/sd1
    print(mean1)
    print(sd1)
    
    
  }
  return(pair1) 
  
}

############################################################################################################
############################################################################################################
####################################          creating pair matrix      ####################################
############################################################################################################
############################################################################################################
testGroups<-function(correct,groupMatrix){
  
  u=dim(groupMatrix)
  u=u[1]
  pair=matrix(nrow=0,ncol=2)
  indicator=matrix(nrow=0,ncol=1)
  
  
  
  for (i in 1:obs){
    temp=colnames(correct[which(!is.na(correct[i,]))])
    for (ind in 1:u){
      if (groupMatrix[ind,1] %in% temp   &  groupMatrix[ind,2] %in% temp  ){
        pair=rbind(pair,c(get(groupMatrix[ind,1],pos=correct[i,]),get(groupMatrix[ind,2],pos=correct[i,])))
        indicator=rbind(indicator,c(ind))
      }
    }
  }
  return(cbind(pair,indicator))
}


#########################################################
###########################################################

wilcxPermutation<-function(pair,num,indicator){
  
  wilcx<-function(pair,indicator){
    
    zz=rank(abs(pair[,2]-pair[,1]))
    zz1=sign(pair[,2]-pair[,1])
    us=zz*zz1
    groups=max(indicator)
    tt=0
    group1=groups
    for (i in 1:groups){
      len=length(which(indicator==i))
      if (len<=1){
        next
        group1=group1-1
      }
      tt=tt+sqrt(length(which(indicator==i)))*sum(us[which(indicator==i)])/sd(us[which(indicator==i)])
      #zz[which(indicator==i)]=zz[which(indicator==i)]/sd(zz)
    }
    return(tt/group1)
  }
  
  
  
  statisticVectr=vector(length=num)
  c=dim(pair)
  c=c[1]
  
  for (i in 1:num){
    
    temp=rbinom(c,1,.5)
    newpair=pair
    newpair[which(temp==1),1]=pair[which(temp==1),2]
    newpair[which(temp==1),2]=pair[which(temp==1),1]
    #print(newpair-pair)
    diff=(newpair[,2]-newpair[,1])
    #statisticVectr[i]=length(diff)*mean(diff)/sd(diff)
    statisticVectr[i]=wilcx(newpair,indicator)
    
  }
  
  
  
  value=wilcx(pair,indicator)
  statisticVectr[num+1]=value
  
  
  return(statisticVectr)
  
}



#########################################################
###########################################################

effectSize<-function(group1,group2){
  vector1=c()
  vector2=c()
  for (i in 1:length(group1)){
    temp=group1[i]
    if(temp %in% colnames(correct)){
      vector1=c(vector1,correct[,c(temp)][which(!is.na(correct[,c(temp)]))])
      }
  }
  for (i in 1:length(group2)){
    temp=group2[i]
    if(temp %in% colnames(correct)){
      vector2=c(vector2,correct[,c(temp)][which(!is.na(correct[,c(temp)]))])
    }
  }
  
  n1=length(vector1)
  n2=length(vector2)
  s1=sd(vector1)
  s2=sd(vector2)
  
  
  sdd1=-(mean(vector2)-mean(vector1))/(      sqrt(   ( (n1-1)*s1*s1+(n2-1)*s2*s2  )/ (n1+n2-2)  )       )
  sdd2=-(mean(vector2)-mean(vector1))/(sd(c(vector1,vector2)))
  return(c(sdd1,sdd2))
  
}




############################################################################################################
############################################################################################################
############################################################################################################
############################################################################################################

wrong=read.table("wrong.csv", header = TRUE, sep = ",") 
correct=read.table("correct.csv", header = TRUE, sep = ",") 

resultMat=matrix(nrow=0,ncol=7)
colnames(resultMat)<-c("groups","mean_group1","mean_group2","observations" ,"permutation","wilcoxon","effect size")
temp=dim(correct)
obs=temp[1]


##################################################################################
#                         check research question flat nested   a<->c            #
##################################################################################
groupMatrix=matrix(nrow=0,ncol=2)
groupMatrix=rbind(groupMatrix,c("three.aStructure","three.cStructure"))
groupMatrix=rbind(groupMatrix,c("three.aLogic","three.cLogic"))

title=" {as,al}-{cs,cl}"

group1=c("three.aStructure","three.aLogic")
group2=c("three.cStructure","three.cLogic")
es=effectSize(group1,group2)

#########
matrix1=testGroups(correct,groupMatrix)
pair=as.matrix(matrix1[,1:2])
indicator=as.matrix(matrix1[,3])
siz=dim(pair)
siz=siz[1]
num=20000
statisticVectr<-pairedPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
pval=1-findInterval(abs(value),sort(abs(statisticVectr)))/num
num=20000
statisticVectr<-wilcxPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
a=1-findInterval(abs(value),sort(abs(statisticVectr)))/num
summary(a)

m1=round(mean(matrix1[,1]),1)
m2=round(mean(matrix1[,2]),1)
sd1=round(sd(matrix1[,1]),1)
sd2=round(sd(matrix1[,2]),1)
temp=dim(matrix1)
temp=temp[1]
resultMat=rbind(resultMat,c(title,paste0(toString(m1),"(",toString(sd1),")"),paste0(toString(m2),"(",toString(sd2),")"),temp,pval,a,es[1]))
##################################################


##################################################


#######$$$$$$$$$$$$$$$$$$$
##################################################################################
#                         check research question flat nested   {cs}-{as}          #
##################################################################################
groupMatrix=matrix(nrow=0,ncol=2)
groupMatrix=rbind(groupMatrix,c("three.aStructure","three.cStructure"))


title="{as}-{cs}"


group1=c("three.aStructure")
group2=c("three.cStructure")
es=effectSize(group1,group2)

#########
matrix1=testGroups(correct,groupMatrix)
pair=as.matrix(matrix1[,1:2])
indicator=as.matrix(matrix1[,3])
siz=dim(pair)
siz=siz[1]
num=20000
statisticVectr<-pairedPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
pval=1-findInterval(abs(value),sort(abs(statisticVectr)))/num
num=20000
statisticVectr<-wilcxPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
a=1-findInterval(abs(value),sort(abs(statisticVectr)))/num
print(a)
summary(a)
m1=round(mean(matrix1[,1]),1)
m2=round(mean(matrix1[,2]),1)
sd1=round(sd(matrix1[,1]),1)
sd2=round(sd(matrix1[,2]),1)
temp=dim(matrix1)
temp=temp[1]
resultMat=rbind(resultMat,c(title,paste0(toString(m1),"(",toString(sd1),")"),paste0(toString(m2),"(",toString(sd2),")"),temp,pval,a,es[1]))




####################################################################################################
##################################################################################
#                         check research question flat nested    {cl}-{al}            #
##################################################################################
groupMatrix=matrix(nrow=0,ncol=2)

groupMatrix=rbind(groupMatrix,c("three.aLogic","three.cLogic"))

title=" {al}-{cl}"

group1=c("three.aLogic")
group2=c("three.cLogic")
es=effectSize(group1,group2)

#########
matrix1=testGroups(correct,groupMatrix)
pair=as.matrix(matrix1[,1:2])
indicator=as.matrix(matrix1[,3])
siz=dim(pair)
siz=siz[1]
num=20000
statisticVectr<-pairedPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
pval=1-findInterval(abs(value),sort(abs(statisticVectr)))/num
num=20000
statisticVectr<-wilcxPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
a=1-findInterval(abs(value),sort(abs(statisticVectr)))/num
print(a)
summary(a)
m1=round(mean(matrix1[,1]),1)
m2=round(mean(matrix1[,2]),1)
sd1=round(sd(matrix1[,1]),1)
sd2=round(sd(matrix1[,2]),1)
temp=dim(matrix1)
temp=temp[1]
resultMat=rbind(resultMat,c(title,paste0(toString(m1),"(",toString(sd1),")"),paste0(toString(m2),"(",toString(sd2),")"),temp,pval,a,es[1]))
####################################################################################################

###########&&&&&&&&&&&&&77



##################################################################################
#                         check research question flat nested   {bs,bl}-{as,al}            #
##################################################################################
groupMatrix=matrix(nrow=0,ncol=2)
groupMatrix=rbind(groupMatrix,c("three.aStructure","three.bStructure"))
groupMatrix=rbind(groupMatrix,c("three.aLogic","three.bLogic"))

title=" {as,al}-{bs,bl}"

group1=c("three.aStructure","three.aLogic")
group2=c("three.bStructure","three.bLogic")
es=effectSize(group1,group2)

#########
matrix1=testGroups(correct,groupMatrix)
pair=as.matrix(matrix1[,1:2])
indicator=as.matrix(matrix1[,3])
siz=dim(pair)
siz=siz[1]
num=20000
statisticVectr<-pairedPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
pval=1-findInterval(abs(value),sort(abs(statisticVectr)))/num
num=20000
statisticVectr<-wilcxPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
a=1-findInterval(abs(value),sort(abs(statisticVectr)))/num
summary(a)
m1=round(mean(matrix1[,1]),1)
m2=round(mean(matrix1[,2]),1)
sd1=round(sd(matrix1[,1]),1)
sd2=round(sd(matrix1[,2]),1)
temp=dim(matrix1)
temp=temp[1]
resultMat=rbind(resultMat,c(title,paste0(toString(m1),"(",toString(sd1),")"),paste0(toString(m2),"(",toString(sd2),")"),temp,pval,a,es[1]))
####################################################################################################


##################################################



#######$$$$$$$$$$$$$$$$$$$
##################################################################################
#                         check research question flat nested   {bs}-{as}           #
##################################################################################
groupMatrix=matrix(nrow=0,ncol=2)
groupMatrix=rbind(groupMatrix,c("three.aStructure","three.bStructure"))


title=" {as}-{bs}"

group1=c("three.aStructure")
group2=c("three.bStructure")
es=effectSize(group1,group2)

#########
matrix1=testGroups(correct,groupMatrix)
pair=as.matrix(matrix1[,1:2])
indicator=as.matrix(matrix1[,3])
siz=dim(pair)
siz=siz[1]
num=20000
statisticVectr<-pairedPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
pval=1-findInterval(abs(value),sort(abs(statisticVectr)))/num
num=20000
statisticVectr<-wilcxPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
a=1-findInterval(abs(value),sort(abs(statisticVectr)))/num
print(a)
summary(a)
m1=round(mean(matrix1[,1]),1)
m2=round(mean(matrix1[,2]),1)
sd1=round(sd(matrix1[,1]),1)
sd2=round(sd(matrix1[,2]),1)
temp=dim(matrix1)
temp=temp[1]
resultMat=rbind(resultMat,c(title,paste0(toString(m1),"(",toString(sd1),")"),paste0(toString(m2),"(",toString(sd2),")"),temp,pval,a,es[1]))
####################################################################################################
##################################################################################
#                         check research question flat nested   {bl}-{al}            #
##################################################################################
groupMatrix=matrix(nrow=0,ncol=2)

groupMatrix=rbind(groupMatrix,c("three.aLogic","three.bLogic"))

title=" {al}-{bl}"

group1=c("three.aLogic")
group2=c("three.bLogic")
es=effectSize(group1,group2)

#########
matrix1=testGroups(correct,groupMatrix)
pair=as.matrix(matrix1[,1:2])
indicator=as.matrix(matrix1[,3])
siz=dim(pair)
siz=siz[1]
num=20000
statisticVectr<-pairedPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
pval=1-findInterval(abs(value),sort(abs(statisticVectr)))/num
num=20000
statisticVectr<-wilcxPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
a=1-findInterval(abs(value),sort(abs(statisticVectr)))/num
print(a)
summary(a)
m1=round(mean(matrix1[,1]),1)
m2=round(mean(matrix1[,2]),1)
sd1=round(sd(matrix1[,1]),1)
sd2=round(sd(matrix1[,2]),1)
temp=dim(matrix1)
temp=temp[1]
resultMat=rbind(resultMat,c(title,paste0(toString(m1),"(",toString(sd1),")"),paste0(toString(m2),"(",toString(sd2),")"),temp,pval,a,es[1]))
####################################################################################################


##################################################################################
#                         check research question negation  {an1,an2}-{an}             #
##################################################################################
groupMatrix=matrix(nrow=0,ncol=2)
groupMatrix=rbind(groupMatrix,c("three.aLogicNegative","three.aLogicNegative1"))
groupMatrix=rbind(groupMatrix,c("three.aLogicNegative","three.aLogicNegative2"))


title=" {an}-{an1,an2}"

group1=c("three.aLogicNegative")
group2=c("three.aLogicNegative1","three.aLogicNegative2")
es=effectSize(group1,group2)

#########
matrix1=testGroups(correct,groupMatrix)
pair=as.matrix(matrix1[,1:2])
indicator=as.matrix(matrix1[,3])
siz=dim(pair)
siz=siz[1]
num=20000
statisticVectr<-pairedPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
pval=1-findInterval(abs(value),sort(abs(statisticVectr)))/num
num=20000
statisticVectr<-wilcxPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
a=1-findInterval(abs(value),sort(abs(statisticVectr)))/num
print(a)
summary(a)
m1=round(mean(matrix1[,1]),1)
m2=round(mean(matrix1[,2]),1)
sd1=round(sd(matrix1[,1]),1)
sd2=round(sd(matrix1[,2]),1)
temp=dim(matrix1)
temp=temp[1]
resultMat=rbind(resultMat,c(title,paste0(toString(m1),"(",toString(sd1),")"),paste0(toString(m2),"(",toString(sd2),")"),temp,pval,a,es[1]))
####################################################################################################





##################################################################################
#                         check research question negation  {an1}-{an}              #
##################################################################################
groupMatrix=matrix(nrow=0,ncol=2)
groupMatrix=rbind(groupMatrix,c("three.aLogicNegative1","three.aLogicNegative"))


title=" {an1}-{an}"

group1=c("three.aLogicNegative1")
group2=c("three.aLogicNegative")
es=effectSize(group1,group2)

#########
matrix1=testGroups(correct,groupMatrix)
pair=as.matrix(matrix1[,1:2])
indicator=as.matrix(matrix1[,3])
siz=dim(pair)
siz=siz[1]
num=20000
statisticVectr<-pairedPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
pval=1-findInterval(abs(value),sort(abs(statisticVectr)))/num
num=20000
statisticVectr<-wilcxPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
a=1-findInterval(abs(value),sort(abs(statisticVectr)))/num
print(a)
summary(a)
m1=round(mean(matrix1[,1]),1)
m2=round(mean(matrix1[,2]),1)
sd1=round(sd(matrix1[,1]),1)
sd2=round(sd(matrix1[,2]),1)
temp=dim(matrix1)
temp=temp[1]
resultMat=rbind(resultMat,c(title,paste0(toString(m1),"(",toString(sd1),")"),paste0(toString(m2),"(",toString(sd2),")"),temp,pval,a,es[1]))
####################################################################################################

##################################################################################
#                         check research question negation  {an2}-{an}             #
##################################################################################
groupMatrix=matrix(nrow=0,ncol=2)
groupMatrix=rbind(groupMatrix,c("three.aLogicNegative2","three.aLogicNegative"))


title="{an2}-{an}"

group1=c("three.aLogicNegative2")
group2=c("three.aLogicNegative")
es=effectSize(group1,group2)

#########
matrix1=testGroups(correct,groupMatrix)
pair=as.matrix(matrix1[,1:2])
indicator=as.matrix(matrix1[,3])
siz=dim(pair)
siz=siz[1]
num=20000
statisticVectr<-pairedPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
pval=1-findInterval(abs(value),sort(abs(statisticVectr)))/num
num=20000
statisticVectr<-wilcxPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
a=1-findInterval(abs(value),sort(abs(statisticVectr)))/num
print(a)
summary(a)
m1=round(mean(matrix1[,1]),1)
m2=round(mean(matrix1[,2]),1)
sd1=round(sd(matrix1[,1]),1)
sd2=round(sd(matrix1[,2]),1)
temp=dim(matrix1)
temp=temp[1]
resultMat=rbind(resultMat,c(title,paste0(toString(m1),"(",toString(sd1),")"),paste0(toString(m2),"(",toString(sd2),")"),temp,pval,a,es[1]))
####################################################################################################


##################################################################################
#                         check research question negation  {f[]}-{f*}            #
##################################################################################
groupMatrix=matrix(nrow=0,ncol=2)
groupMatrix=rbind(groupMatrix,c("three.forArithmetic","three.forArray"))


title=" {f*}-{f[]}"

group1=c("three.forArithmetic")
group2=c("three.forArray")
es=effectSize(group1,group2)

#########
matrix1=testGroups(correct,groupMatrix)
pair=as.matrix(matrix1[,1:2])
indicator=as.matrix(matrix1[,3])
siz=dim(pair)
siz=siz[1]
num=20000
statisticVectr<-pairedPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
pval=1-findInterval(abs(value),sort(abs(statisticVectr)))/num
num=20000
statisticVectr<-wilcxPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
a=1-findInterval(abs(value),sort(abs(statisticVectr)))/num

summary(a)
m1=round(mean(matrix1[,1]),1)
m2=round(mean(matrix1[,2]),1)
sd1=round(sd(matrix1[,1]),1)
sd2=round(sd(matrix1[,2]),1)
temp=dim(matrix1)
temp=temp[1]
resultMat=rbind(resultMat,c(title,paste0(toString(m1),"(",toString(sd1),")"),paste0(toString(m2),"(",toString(sd2),")"),temp,pval,a,es[1]))
####################################################################################################


##################################################################################
#                         check research question negation  {cl,cs}-{bl,bs}             #
##################################################################################
groupMatrix=matrix(nrow=0,ncol=2)
groupMatrix=rbind(groupMatrix,c("three.bLogic","three.cLogic"))
groupMatrix=rbind(groupMatrix,c("three.bStructure","three.cStructure"))


title=" {bl,bs}-{cl,cs}"

group1=c("three.bLogic","three.bStructure")
group2=c("three.cLogic","three.cStructure")
es=effectSize(group1,group2)

#########
matrix1=testGroups(correct,groupMatrix)
pair=as.matrix(matrix1[,1:2])
indicator=as.matrix(matrix1[,3])
siz=dim(pair)
siz=siz[1]
num=20000
statisticVectr<-pairedPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
pval=1-findInterval(abs(value),sort(abs(statisticVectr)))/num
num=20000
statisticVectr<-wilcxPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
a=1-findInterval(abs(value),sort(abs(statisticVectr)))/num
summary(a)
m1=round(mean(matrix1[,1]),1)
m2=round(mean(matrix1[,2]),1)
sd1=round(sd(matrix1[,1]),1)
sd2=round(sd(matrix1[,2]),1)
temp=dim(matrix1)
temp=temp[1]
resultMat=rbind(resultMat,c(title,paste0(toString(m1),"(",toString(sd1),")"),paste0(toString(m2),"(",toString(sd2),")"),temp,pval,a,es[1]))
####################################################################################################



##################################################################################
#                         check research question negation  {cl}-{bl}              #
##################################################################################
groupMatrix=matrix(nrow=0,ncol=2)
groupMatrix=rbind(groupMatrix,c("three.bLogic","three.cLogic"))


title=" {bl}-{cl}"

group1=c("three.bLogic")
group2=c("three.cLogic")
es=effectSize(group1,group2)

#########
matrix1=testGroups(correct,groupMatrix)
pair=as.matrix(matrix1[,1:2])
indicator=as.matrix(matrix1[,3])
siz=dim(pair)
siz=siz[1]
num=20000
statisticVectr<-pairedPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
pval=1-findInterval(abs(value),sort(abs(statisticVectr)))/num
num=20000
statisticVectr<-wilcxPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
a=1-findInterval(abs(value),sort(abs(statisticVectr)))/num
summary(a)
m1=round(mean(matrix1[,1]),1)
m2=round(mean(matrix1[,2]),1)
sd1=round(sd(matrix1[,1]),1)
sd2=round(sd(matrix1[,2]),1)
temp=dim(matrix1)
temp=temp[1]
resultMat=rbind(resultMat,c(title,paste0(toString(m1),"(",toString(sd1),")"),paste0(toString(m2),"(",toString(sd2),")"),temp,pval,a,es[1]))
####################################################################################################


##################################################################################
#                         check research question negation  {cs}-{bs}              #
##################################################################################
groupMatrix=matrix(nrow=0,ncol=2)
groupMatrix=rbind(groupMatrix,c("three.bStructure","three.cStructure"))


title=" {bs}-{cs}"

group1=c("three.bStructure")
group2=c("three.cStructure")
es=effectSize(group1,group2)

#########
matrix1=testGroups(correct,groupMatrix)
pair=as.matrix(matrix1[,1:2])
indicator=as.matrix(matrix1[,3])
siz=dim(pair)
siz=siz[1]
num=20000
statisticVectr<-pairedPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
pval=1-findInterval(abs(value),sort(abs(statisticVectr)))/num
num=20000
statisticVectr<-wilcxPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
a=1-findInterval(abs(value),sort(abs(statisticVectr)))/num
summary(a)
m1=round(mean(matrix1[,1]),1)
m2=round(mean(matrix1[,2]),1)
sd1=round(sd(matrix1[,1]),1)
sd2=round(sd(matrix1[,2]),1)
temp=dim(matrix1)
temp=temp[1]
resultMat=rbind(resultMat,c(title,paste0(toString(m1),"(",toString(sd1),")"),paste0(toString(m2),"(",toString(sd2),")"),temp,pval,a,es[1]))
####################################################################################################






##################################################################################
#                         check research question negation  {an1}-{an2}              #
##################################################################################
groupMatrix=matrix(nrow=0,ncol=2)
groupMatrix=rbind(groupMatrix,c("three.aLogicNegative1","three.aLogicNegative2"))


title=" {an1}-{an2}"


group1=c("three.aLogicNegative1")
group2=c("three.aLogicNegative2")
es=effectSize(group1,group2)

#########
matrix1=testGroups(correct,groupMatrix)
pair=as.matrix(matrix1[,1:2])
indicator=as.matrix(matrix1[,3])
siz=dim(pair)
siz=siz[1]
num=20000
statisticVectr<-pairedPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
pval=1-findInterval(abs(value),sort(abs(statisticVectr)))/num
num=20000
statisticVectr<-wilcxPermutation(pair,num,indicator)  
value=statisticVectr[num+1]
statisticVectr=statisticVectr[1:num]
a=1-findInterval(abs(value),sort(abs(statisticVectr)))/num
summary(a)
m1=round(mean(matrix1[,1]),1)
m2=round(mean(matrix1[,2]),1)
sd1=round(sd(matrix1[,1]),1)
sd2=round(sd(matrix1[,2]),1)
temp=dim(matrix1)
temp=temp[1]
resultMat=rbind(resultMat,c(title,paste0(toString(m1),"(",toString(sd1),")"),paste0(toString(m2),"(",toString(sd2),")"),temp,pval,a,es[1]))
####################################################################################################






###########&&&&&&&&&&&&&77


